﻿<?php
/**
 * 易游支付 https://yy.296o.com/
 * 功能：接口请求提交类
 * 详细：构造接口表单HTML文本，获取远程HTTP数据
 * 版本：1.0
 * 日期：2020-01-01
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究聚合支付接口使用，只是提供一个参考。
 */ 
 
require_once("pay_core.function.php");
require_once("pay_md5.function.php");

class PaySubmit {

	var $pay_config;

	function __construct($pay_config){
		$this->pay_config = $pay_config;
	}
    function PaySubmit($pay_config) {
    	$this->__construct($pay_config);
    }
	
	/**
	 * 生成签名结果
	 * @param $para_sort 已排序要签名的数组
	 * return 签名结果字符串
	 */
	function buildRequestMysign($para_sort) {
		//把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串
		$prestr = createLinkstring($para_sort);
		
		$mysign = md5Sign($prestr, $this->pay_config['appkey']);

		return $mysign;
	}

	/**
     * 生成要请求给支付接口的参数数组
     * @param $para_temp 请求前的参数数组
     * @return 要请求的参数数组
     */
	function buildRequestPara($para_temp) {
		//除去待签名参数数组中的空值和签名参数
		$para_filter = paraFilter($para_temp);
		//对待签名参数数组排序
		$para_sort = argSort($para_filter);
		//生成签名结果
		$mysign = $this->buildRequestMysign($para_sort);
		//提交签名数组字符串（测试）
		$para_sort['signArray'] = createLinkstring($para_sort);			
		//签名结果与签名方式加入请求提交参数组中
		$para_sort['sign'] = $mysign;	
		return $para_sort;
	}

	/**
     * 生成要请求给支付接口的参数数组
     * @param $para_temp 请求前的参数数组
     * @return 要请求的参数数组字符串
     */
	function buildRequestParaToString($para_temp) {
		//待请求参数数组
		$para = $this->buildRequestPara($para_temp);		
		//把参数组中所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串，并对字符串做urlencode编码
		$request_data = createLinkstringUrlencode($para);		
		return $request_data;
	}
	
    /**
     * 建立请求，以表单HTML形式构造（默认）
     * @param $para_temp 请求参数数组
     * @param $method 提交方式。两个值可选：post、get
     * @param $button_name 确认按钮显示文字
     * @return 提交表单HTML文本
     */
	function buildRequestForm($para_temp, $method='POST', $button_name='正在跳转到支付') {
		//待请求参数数组
		$para = $this->buildRequestPara($para_temp);		
		$sHtml = "<form id='PaySubmit' name='PaySubmit' action='".$this->pay_config['apiurl']."?charset=".trim(strtolower($this->pay_config['charset']))."' method='".$method."'>";
		while (list ($key, $val) = each ($para)) {
            $sHtml.= "<input type='hidden' name='".$key."' value='".$val."'/>";
        }
		//submit按钮控件请不要含有name属性
        $sHtml = $sHtml."<input type='submit' value='".$button_name."'></form>";		
		$sHtml = $sHtml."<script>document.forms['PaySubmit'].submit();</script>";		
		return $sHtml;
	}
}
?>